/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/4/practice/contest/280801/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vi a(n);
    cin >> a;

    while (__builtin_popcount(n) != 1) {
        n++;
        a.push_back(0);
    }

    V<pair<ll, ll>> seg(n * 2);
    vl lazy(n * 2);

    auto merge = [&](pair<ll, ll> a, pair<ll, ll> b) -> pair<ll, ll> {
        return {a.first + b.first, a.second + b.second};
    };

    nrep(i, n, n * 2) {
        seg[i] = {a[i - n], a[i - n] * (i - n + 1)};
    }

    for (int i = n - 1; i > 0; i--) {
        seg[i] = merge(seg[i * 2], seg[i * 2 + 1]);
    }

    auto propagate = [&](int i, int l, int r) {
        if (lazy[i] == 0) {
            return;
        }

        ll size = (r - l + 1);

        seg[i].first += lazy[i] * size;
        seg[i].second += lazy[i] * (size * (r + l + 2) / 2);

        if (i < n) {
            lazy[i * 2] += lazy[i];
            lazy[i * 2 + 1] += lazy[i];
        }

        lazy[i] = 0;
    };

    function<void(int, int, int, int, int, int)> update = [&](int i, int l, int r, int tl, int tr, int v) {
        propagate(i, l, r);

        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazy[i] += v;
            propagate(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, v);

        seg[i] = merge(seg[i * 2], seg[i * 2 + 1]);
    };

    function<pair<ll, ll>(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) -> pair<ll, ll> {
        if (l > tr || r < tl) {
            return {0, 0};
        }

        propagate(i, l, r);

        if (l >= tl && r <= tr) {
            return seg[i];
        }

        int mid = (l + r) >> 1;

        return merge(query(i * 2, l, mid, tl, tr), query(i * 2 + 1, mid + 1, r, tl, tr));
    };

    while (m--) {
        int op;
        cin >> op;

        if (op == 1) {
            int l, r, d;
            cin >> l >> r >> d;
            update(1, 0, n - 1, l - 1, r - 1, d);
            continue;
        }

        int l, r;
        cin >> l >> r;

        auto ans = query(1, 0, n - 1, l - 1, r - 1);

        cout << ans.second - ans.first * (l - 1) << '\n';
    }
}
